SystemOrganization addCategory: #'tODE-Metacello'!

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 04:06'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewPackageClasses;
		renderer:
				((TOPackageSidebar new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'package classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 11:11'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: ((TOPackage new)
			mbPackageInfo: self;
			yourself);  
		sidebarSpec: self tODEViewSidebarSpec;
		yourself! !

!MBPackageInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 09:52'!
todeCssClass
	|  wc loadedPkgName cssSpanClass |
	(wc := self workingCopy) isNil
		ifTrue: [ ^ super todeCssClass ].
	cssSpanClass := ''.
	wc ancestry ancestors notEmpty
		ifTrue: [ 
			loadedPkgName := wc ancestry ancestors first name.
			loadedPkgName = self name
				ifFalse: [ 
					(self compareWorkingCopyNamed: loadedPkgName using: #<=)
						ifTrue: [ cssSpanClass := 'outofspec ' ].
					cssSpanClass := cssSpanClass , 'mismatch ' ] ].
	self isDirty
		ifTrue: [ cssSpanClass := cssSpanClass , 'dirty ' ].
	^cssSpanClass! !

!MCPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 12:28'!
renderViewSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer mcPatch: self.
	aTOTabSpec renderer renderContentOn: html main: main! !

!MCPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 12:29'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewPackageClasses;
		rendererClass: TOPatchList;
		receiver: self;
		label: 'changes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderViewSidebarOn:spec:tOdeMain:)}! !

!MCPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 11:25'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #view;
		rendererClass: TOPatch;  
		receiver: self;
		label: 'view';
		order: 5;
		group: 'basic';
		sidebarSpec: self tODEViewSidebarSpec;
		renderSelector: #renderViewContentOn:spec:main:! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/22/2011 11:00'!
renderCommandsOn: html for: aTOMetacelloView main: main
	| commands |
	commands := ((self commands select: [ :each | each istODECommand ])
		collect: [ :commandClass | commandClass target: self for: nil ]) asArray sort: [ :a :b | a order <= b order ].
	commands isEmpty
		ifTrue: [ ^ self ].
	commands do: [ :command | 
		command renderCommandOn: html for: aTOMetacelloView main: main.
		html break ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 12:46'!
renderFrameTitleOn: html main: main
	| cl |
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	(html div)
		class: 'naviode';
		with: [ 
					self renderStyledLabelOn: html main: main.
					html space.
					html small: '(' , cl name , ')' ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 21:13'!
renderLabelOn: html main: main
	(html div)
		class: 'naviode';
		with: [ self renderStyledLabelOn: html main: main ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 10:00'!
renderStyledLabelOn: html main: main
	(html span)
		class: self todeCssClass;
		with: [ html text: self printString ]! !

!MBInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 09:52'!
todeCssClass
	^ 'default'! !

!MBPackageHistoryCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 19:47'!
istODECommand

	^true! !

!MBPackageHistoryCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 09:43'!
renderCommandOn: html for: aTOMetacelloView main: main
	| wc |
	wc := target spec workingCopy ifNil: [ ^ self ].
	wc ancestors isEmpty
		ifTrue: [ ^ self ].
	(html submitButton)
		onClick:
				(html jQuery ajax
						script: [ :s | 
							| infos ancestry |
							ancestry := wc ancestors first.
							infos := (TOCollection new)
								label: 'History for ' , target name;
								collection: ancestry withBreadthFirstAncestors;
								selectedTab: #view;
								printStringBlock: [ :item | item name , ' (' , item date asString , ', ' , item time asString , ')' ];
								itemRenderBlock: [ :item :r :m | r preformatted: item summary ];
								yourself.
							aTOMetacelloView currentSession push: infos selecting: #view.
							main updateCenterSideHistory: s ]);
		with: 'history'! !

!MetacelloMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/27/2011 14:40'!
isAdd
	^ false! !

!MetacelloMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/27/2011 14:40'!
isCopy
	^ false! !

!MetacelloMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/27/2011 14:40'!
isMerge
	^ false! !

!MetacelloMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/27/2011 14:40'!
isRemove
	^ false! !

!MBVersionInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 05:47'!
tODEViewTabSpec
	<tODECenterTabSpec>
	^ (super tODEViewTabSpec)
		renderer:
				((TOVersion new)
						object: self;
						mbVersionInfo: self;
						yourself);
		sidebarSpec: self tODEVersionSidebarSpec;
		yourself! !

!MetacelloRemoveMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/28/2011 20:32'!
isRemove
	^ true! !

!MBBaselineInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 05:48'!
tODEViewTabSpec
	<tODECenterTabSpec>
	^ (super tODEViewTabSpec)
		renderer:
				((TOBaselineVersion new)
						object: self;
						mbVersionInfo: self;
						yourself);
		sidebarSpec: self tODEVersionSidebarSpec;
		yourself! !

!TOSystem methodsFor: '*tode-metacello' stamp: 'dkh 6/3/2011 16:06'!
configurationRoot

	^MBConfigurationRoot current! !

TOSidebar subclass: #TOPackageSidebar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOPackageSidebar subclass: #TOConfigurationSidebar
	instanceVariableNames: 'selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:22'!
configurationInfo

	^(self frame rendererForCenterTab: self specLabel) mbConfigurationInfo! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/14/2011 09:47'!
defaultSpecLabel
	^ #configuration! !

!TOConfigurationSidebar methodsFor: 'rendering' stamp: 'dkh 6/13/2011 21:43'!
renderContentOn: html main: main
	| id |
	(html select)
		id: (id := html nextId);
		list: self selectionList;
		selected: self selection;
		callback: [ :index | self selectIndex: index ];
		onChange:
				((html jQuery ajax)
						callback: [ :index | self selectIndex: index ] value: (html jQuery id: id) value;
						script: [ :s | main updateSidebarOn: s ]).
	html break.
	self selection = 'classes'
		ifTrue: [ ^ self renderClassListOn: html main: main ].
	self selection = 'currentVersion'
		ifTrue: [ ^ self renderCurrentVersionOn: html main: main ].
	self selection = 'versions'
		ifTrue: [ ^ self renderVersionListOn: html main: main ]! !

!TOConfigurationSidebar methodsFor: 'rendering' stamp: 'dkh 6/14/2011 10:24'!
renderCurrentVersionOn: html main: main
	| cvs list cv |
	self configurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			^ self ].
	cvs := ''.
	(cv := self configurationInfo currentVersion) ~~ nil
		ifTrue: [ cvs := cv versionString , ' ' ].
	(html heading)
		level: 3;
		with: self configurationInfo printString.
	(html div)
		class: 'naviode';
		with: [ 
					(list := self configurationInfo projects) notEmpty
						ifTrue: [ 
							html
								text: ' -- ' , cvs , 'projects --';
								break.
							list
								do: [ :info | 
									| projectConfig |
									(projectConfig := info projectConfiguration) notNil
										ifTrue: [ 
											self
												renderLink: [ :s | 
													self currentSession push: projectConfig selecting: #view.
													main updateCenterSideHistory: s ]
												with: [ info renderLabelOn: html main: main ]
												on: html ]
										ifFalse: [ 
											info renderLabelOn: html main: main.
											html break ] ].
							html break ].
					(list := self configurationInfo packages) notEmpty
						ifTrue: [ 
							html
								text: ' -- ' , cvs , 'packages --';
								break.
							list
								do: [ :info | 
									info workingCopy
										ifNil: [ 
											info renderLabelOn: html main: main.
											html break ]
										ifNotNil: [ 
											self
												renderLink: [ :s | 
													self currentSession push: info selecting: #view.
													main updateCenterSideHistory: s ]
												with: [ info renderLabelOn: html main: main ]
												on: html ] ].
							html break ].
					(list := self configurationInfo groups) notEmpty
						ifTrue: [ 
							html
								text: ' -- ' , cvs , 'groups --';
								break.
							list do: [ :info | info renderLabelOn: html main: main ] ] ]! !

!TOConfigurationSidebar methodsFor: 'rendering' stamp: 'dkh 6/14/2011 10:24'!
renderVersionListOn: html main: main
	self configurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			^ self ].
	(html heading)
		level: 3;
		with: self configurationInfo printString.
	(html div)
		class: 'naviode';
		with: [ 
					self configurationInfo project
						ifNil: [ 
							^ (html span)
								class: 'error';
								with: 'no project defined' ].
					html
						text: ' -- baselines --';
						break.
					(self configurationInfo trimVersionInfos: self configurationInfo baselines)
						do: [ :info | 
							(info isKindOf: MBAbstractVersionInfo)
								ifTrue: [ 
									self
										renderLink: [ :s | 
											self currentSession push: info selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ info renderLabelOn: html main: main ]
										on: html ]
								ifFalse: [ 
									info renderLabelOn: html main: main.
									html break ] ].
					html
						break;
						text: ' -- versions --';
						break.
					(self configurationInfo trimVersionInfos: self configurationInfo versions)
						do: [ :info | 
							(info isKindOf: MBAbstractVersionInfo)
								ifTrue: [ 
									self
										renderLink: [ :s | 
											self currentSession push: info selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ info renderLabelOn: html main: main ]
										on: html ]
								ifFalse: [ 
									info renderLabelOn: html main: main.
									html break ] ] ]! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:26'!
selectIndex: index

	selection := self selectionList at: index asInteger! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 21:02'!
selection

	selection ifNil: [ selection := 'currentVersion' ].
	^ selection! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:56'!
selection: anObject
	selection := anObject! !

!TOConfigurationSidebar methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:58'!
selectionList

	^{'classes'. 'currentVersion'. 'versions'. }.
! !

!TOPackageSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 04:17'!
defaultSpecLabel
	^ #package! !

!TOPackageSidebar methodsFor: 'rendering' stamp: 'dkh 6/17/2011 10:20'!
renderClassListOn: html main: main
	| order classes indents displayString classList extensionClassList |
	order := SortedCollection
		sortBlock: [ :assoc1 :assoc2 | 
			| result chain1 chain2 max i |
			result := nil.
			chain1 := assoc1 key.
			chain2 := assoc2 key.
			max := chain1 size min: chain2 size.
			i := 1.
			[ result isNil and: [ i <= max ] ]
				whileTrue: [ 
					(chain1 at: i) = (chain2 at: i)
						ifTrue: [ i := i + 1 ]
						ifFalse: [ result := (chain1 at: i) name < (chain2 at: i) name ] ].
			result isNil
				ifTrue: [ chain1 size < chain2 size ]
				ifFalse: [ result ] ].
	classList := (self frame rendererForCenterTab: self specLabel) classList.
	extensionClassList := (self frame rendererForCenterTab: self specLabel) extensionClassList.
	classList
		do: [ :cl | extensionClassList removeKey: cl ifAbsent: []].
	classes :=  classList, extensionClassList keys.
	classes
		do: [ :cl | 
			| supersChain |
			supersChain := cl withAllSuperclasses reversed.
			supersChain removeAllSuchThat: [ :class | (classes includes: class) not ].
			order add: supersChain contents -> cl ].
	indents := IdentityDictionary new.
	order do: [ :assoc | indents at: assoc value put: assoc key size - 1 ].
	classes := classes asArray sorted: [ :a :b | a name <= b name ].
	order
		do: [ :assoc | 
			| cl |
			cl := assoc value.
			(indents at: cl) * 2 timesRepeat: [ html space ].
			self
				renderLink: [ :s | | fr |
					fr := self currentSession push: cl selecting: ((extensionClassList includesKey: cl)
								ifTrue: [#methodSourceBrowser]
								ifFalse: [#classBrowser]).
					(extensionClassList includesKey: cl)
						ifTrue: [| browser selector |
							browser := fr rendererForCenterTab: #methodSourceBrowser.
							selector := (cl organization listAtCategoryNamed: (extensionClassList at: cl) first) first.
							browser methodReference: (SourcedMethodReference class: cl selector: selector) ].
					main updateCenterSideHistory: s ]
				with: [ 
					(extensionClassList includesKey: cl)
								ifTrue: [html text: cl name asString]
								ifFalse: [html strong: cl name asString].
					html break ]
				on: html ]! !

!TOPackageSidebar methodsFor: 'rendering' stamp: 'dkh 6/13/2011 20:49'!
renderContentOn: html main: main
	self renderClassListOn: html main: main! !

TOSidebar subclass: #TOVersionSidebar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOVersionSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 04:17'!
defaultSpecLabel
	^ #version! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:45'!
indent: count on: html
	self toVersion indent: count on: html! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:46'!
indentIncrement
	^ self toVersion indentIncrement! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:46'!
label: labelBlock on: html
	self toVersion label: labelBlock value: nil on: html
! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:46'!
label: labelBlock value: valueBlock on: html
	self toVersion label: labelBlock value: valueBlock on: html! !

!TOVersionSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:17'!
mbConfigurationInfo

	^self toVersion mbConfigurationInfo! !

!TOVersionSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:17'!
mbVersionInfo

	^self toVersion mbVersionInfo! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/25/2011 05:18'!
renderContentOn: html main: main
	self renderViewContentOn: html main: main! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/25/2011 05:18'!
renderFrameTitleOn: html main: main
	| cl |
	self mbConfigurationInfo ifNil: [ ^ super renderFrameTitleOn: html main: main ].
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	html strong: (MBToolBox baseNameOf: self mbConfigurationInfo name).
	html space.
	html text: 'version'.
	html space.
	html strong: self mbVersionInfo versionString.
	html space.
	html small: '(' , cl name , ')'! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 18:18'!
renderViewContentOn: html main: main
	| vms indent selectedSection |
	(vms := self versionMethodSpec) ifNil: [ ^ super renderViewContentOn: html main: main ].
	indent := 0.
	(html span)
		class: 'shout';
		with: [ 
					self
						renderLink: [ :s | 
							(self toVersion)
								aspect: nil;
								aspectPath: nil.
							main updateCenterSideHistory: s ]
						with: [ self label: [ html text: 'version' ] on: html ]
						on: html.
					html text: ': '.
					html strong: vms versionString.
					vms imports notEmpty
						ifTrue: [ 
							html space.
							self label: [ html text: 'imports: ' ] on: html.
							vms imports
								do: [ :import | 
									self
										renderLink: [ :s | 
											self currentSession push: (self mbVersionInfo configurationInfo infoFor: import) selecting: #view.
											main updateCenterSideHistory: s ]
										with: [ html strong: import ]
										on: html.
									html space ] ].
					html break.
					selectedSection := nil.
					self toVersion aspectPath notEmpty
						ifTrue: [ selectedSection := self toVersion aspectPath first ].
					vms methodSections
						do: [ :section | 
							| path |
							(selectedSection isNil or: [ selectedSection = section ])
								ifTrue: [ 
									self indent: indent on: html.
									self
										renderLink: [ :s | 
											(self toVersion)
												aspect: #section;
												aspectPath: {section}.
											main updateCenterSideHistory: s ]
										with: [ 
											(html span)
												class: 'symbol';
												with: [ html text: section attribute printString ] ]
										on: html.
									html break.
									self toVersion
										renderVersionSpec: section versionSpec
										path: {section}
										indent: indent + self indentIncrement
										on: html
										main: main.
									self toVersion
										renderPackagesSpecs: section versionSpec
										path: {section}
										indent: indent + self indentIncrement
										on: html
										main: main ] ] ]! !

!TOVersionSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:16'!
toVersion

	^self frame rendererForCenterTab: self specLabel! !

!TOVersionSidebar methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:46'!
value: valueBlock on: html
	self toVersion label: nil value: valueBlock on: html
! !

!TOVersionSidebar methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:18'!
versionMethodSpec

	^self toVersion versionMethodSpec! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 5/8/2011 08:29'!
baselineInfoFor: aVersionString

	^self baselines detect: [:each | each versionString = aVersionString ]! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 15:47'!
infoFor: aVersionString
	^ self baselines
		detect: [ :each | each versionString = aVersionString ]
		ifNone: [ self versions detect: [ :each | each versionString = aVersionString ] ]! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/22/2011 11:24'!
renderCommandsOn: html for: aTOMetacelloView main: main
	super renderCommandsOn: html for: aTOMetacelloView main: main! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/23/2011 17:22'!
tODEViewSidebarSpec
	^ {((TOTabSpec new)
		id: #viewConfigurationClasses;
		renderer:
				((TOConfigurationSidebar new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'configuration view classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 11:24'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: ((TOConfiguration new)
			mbConfigurationInfo: self;
			yourself);  
		sidebarSpec: self tODEViewSidebarSpec;
		yourself! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 09:59'!
todeCssClass
	| cv specVersion wc cssSpanClass |
	[ 
	cssSpanClass := ''.
	((wc := self workingCopy) notNil and: [ wc needsSaving ])
		ifTrue: [ cssSpanClass := 'dirty ' ].
	self isDirty
		ifTrue: [ cssSpanClass := 'contentsdirty ' , cssSpanClass ].
	self currentVersion.	"prime the pump"
	currentVersion == #notLoaded
		ifTrue: [ ^ cssSpanClass ].
	super isDirty | self currentVersionMismatch
		ifTrue: [ cssSpanClass := 'mismatch ' , cssSpanClass ].
	self currentVersion versionStatus == #somethingLoaded
		ifTrue: [ cssSpanClass := cssSpanClass , 'somethingloaded ' ].
	^ cssSpanClass ] on: Error do: [ :ex | ^ 'error' ]! !

!MBConfigurationInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 21:23'!
versionInfoFor: aVersionString

	^self versions detect: [:each | each versionString = aVersionString ]! !

!MetacelloCopyMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/28/2011 20:29'!
isCopy
	^ true! !

!MCWorkingCopy methodsFor: '*tode-metacello' stamp: 'dkh 6/15/2011 16:08'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #view;
		renderer: ((TOWorkingCopy new)
			workingCopy: self;
			yourself);  
		receiver: self;
		label: 'view';
		order: 5;
		group: 'basic';
		renderSelector: #renderViewContentOn:spec:main:! !

!MetacelloSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 09:52'!
renderViewContentOn: html main: main
	html preformatted: self printString
! !

!MBAbstractVersionInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 16:31'!
renderFrameTitleOn: html main: main
	| cl |
	self configurationInfo ifNil: [ ^ super renderFrameTitleOn: html main: main ].
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	html strong: (MBToolBox baseNameOf: self configurationInfo name).
	html space.
	html text: 'version'.
	html space.
	html strong: self versionString.
	html space.
	html small: '(' , cl name , ')'! !

!MBAbstractVersionInfo methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 05:44'!
tODEVersionSidebarSpec
	^ {((TOTabSpec new)
		id: #versionSpec;
		renderer:
				((TOVersionSidebar new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'version spec';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!MetacelloVersionMethodSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 15:33'!
renderViewContentOn: html main: main
	html text: 'verrsion: '.
	html text: self versionString printString.
	html space.
	html text: 'imports: #('.
	self imports
		do: [ :import | 
			html text: import printString.
			html space ].
	html text: ')'.
	html break.
	self methodSections
		do: [ :section | 
			section renderViewContentOn: html main: main.
			html break ]! !

!TextDiffBuilder methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 14:36'!
renderContentOn: html view: aTOPatch main: main
	| lineEndings |
	lineEndings := String cr , String lf.
	(html div)
		class: 'naviode';
		with: [ 
					html
						preformatted: [ 
							self
								patchSequenceDoIfMatch: [ :string | html text: string; break ]
								ifInsert: [ :string | 
									(html span)
										class: 'insert';
										with: [ html text: string; break ] ]
								ifRemove: [ :string | 
									(html span)
										class: 'remove';
										with: [ html text: string; break ] ] ] ]! !

!MBRevertPackageCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 12:55'!
istODECommand

	^true! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 08:36'!
basePackageName
	^ target workingCopy packageName copyUpToLast: #-! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 19:31'!
renderCommandOn: html for: aTOMetacelloView main: main
	| selectedName ancestors ancestorNames id ajax |
	ancestors := target workingCopy ancestry breadthFirstAncestors.
	ancestors isEmpty
		ifTrue: [ ^ self ].
	ancestorNames := ancestors collect: [ :ea | ea name ].
	selectedName := ancestorNames first.
	ajax := html jQuery ajax.
	target workingCopy modified
		ifTrue: [ 
			ajax
				confirm:
					'You are about to load a new version of ' , self basePackageName printString
						, ' that has unsaved changes in the image.  If you continue, you will lose these changes?' ].
	ajax
		script: [ :s | 
			self
				revertPackage: (ancestors at: (ancestorNames indexOf: selectedName))
				for: aTOMetacelloView
				script: s
				main: main ].
	(html submitButton)
		onClick: ajax;
		with: self todeTitle.
	(html select)
		id: (id := html nextId);
		list: ancestorNames;
		selected: selectedName;
		onChange: (html jQuery ajax callback: [ :value | selectedName := value ] value: (html jQuery id: id) value)! !

!MBRevertPackageCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 11:12'!
revertPackage: info for: aTOMetacelloView script: s main: main
	"unconditional loading by the time this method is called ... overrides modified packages."

	[ 
	(target workingCopy repositoryGroup versionWithInfo: info ifNone: [ ^ s alert: 'No repository found for ' , info name ])
		load ] on: Warning do: [ :ex | ex resume: true ].
	s alert: 'Reverted: ' , info name.
	main updateCenterSideHistory: s! !

!MCPatchOperation methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 16:50'!
renderContentOn: html view: aTOPatch main: main
	self renderNavigationOn: html view: aTOPatch main: main.
	^ self isClassPatch
		ifTrue: [ (TextDiffBuilder from: self fromSource to: self toSource) renderContentOn: html view: aTOPatch main: main ]
		ifFalse: [ 
			(TextDiffBuilder from: self fromSource to: self toSource inClass: self targetClass)
				renderContentOn: html
				view: aTOPatch
				main: main ]! !

!MCPatchOperation methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 19:03'!
renderNavigationOn: html view: aTOPatch main: main

	| class |
	(class := self targetClass) ifNil: [ ^html strong: self targetClass name asString ].
	aTOPatch
		renderLink: [ :s | 
			main currentSession push: class selecting: #methodClassBrowser.
			main updateCenterSideHistory: s ]
		with: [html strong: class name asString]
		on: html.
	self isClassPatch ifTrue: [ ^self ].
	html text: '>>'.
	aTOPatch
		renderLink: [ :s | | fr selector |
			fr := main currentSession push: class selecting: #methodSourceBrowser.
selector := self definition selector.
(class includesSelector: selector)
  ifTrue: [ 
			(fr rendererForCenterTab: #methodSourceBrowser) methodReference: (MethodReference class: class selector: selector) ].
			main updateCenterSideHistory: s ]
		with: [html strong: self definition selector]
		on: html.
! !

!MetacelloAddMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/28/2011 20:28'!
isAdd
	^ true! !

!MetacelloMergeMemberSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/28/2011 20:29'!
isMerge
	^ true! !

!MBCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 12:55'!
istODECommand

	^false! !

!MBCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/11/2011 17:55'!
renderCommandOn: html for: aTOMetacelloView main: main
	aTOMetacelloView
		renderButton: [ :s | 
			self execute.
			main updateCenterSideHistory: s ]
		label: self todeTitle
		on: html! !

!MBCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 17:39'!
todeTitle

	^self title! !

!TOHome methodsFor: '*tode-metacello' stamp: 'dkh 6/21/2011 14:20'!
renderMetacelloHomeViewContentOn: html spec: aTOTabSpec main: main
	<tODEHomeView>
	| projectList |
	projectList := self properties
		at: #metacelloProjectList
		ifAbsent: [ self properties at: #metacelloProjectList put: (TOConfigurationList new frame: self frame) ].
	projectList resetSearch.
	html strong: 'Projects ('.
	self
		renderLink: [ :s | 
			projectList showDetails: projectList showDetails not.
			main updateCenterSideHistory: s ]
		with: [ 
			projectList showDetails
				ifTrue: [ html text: 'names' ]
				ifFalse: [ html text: 'details' ] ]
		on: html.
	html strong: '):'.
	html unorderedList: [ projectList renderViewContentOn: html main: main ]! !

!TOSearch methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 08:08'!
configurationQueryResults
	<todeSearch: 'Configurations' selector: #configurationSearch priority: 35>
	^ (MBConfigurationRoot current configurations select: [ :ci | ci name includesSubstring: searchText caseSensitive: false ]) sorted: [ :a :b | a name <= b name ]! !

!TOSearch methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 07:42'!
packageQueryResults
	<todeSearch: 'Packages' selector: #packageSearch priority: 30>
	^ (MCWorkingCopy allManagers select: [ :wc | wc packageName includesSubstring: searchText caseSensitive: false ])
		sorted: [ :a :b | a packageName <= b packageName ]! !

!MBPackageChangesCommand class methodsFor: '*tode-metacello' stamp: 'dkh 6/14/2011 11:02'!
istODECommand

	^true! !

!MBPackageChangesCommand methodsFor: '*tode-metacello' stamp: 'dkh 6/24/2011 09:42'!
renderCommandOn: html for: aTOMetacelloView main: main
	| selectedName id wc repos names |
	wc := target spec workingCopy ifNil: [ ^ self ].
	wc ancestors isEmpty
		ifTrue: [ ^ self ].
	repos := wc repositoryGroup repositories.
	names := repos collect: [ :r | r description ].
	selectedName := names first.
	(html submitButton)
		onClick:
				(html jQuery ajax
						script: [ :s | 
							| patch |
							patch := wc changesRelativeToRepository: (repos at: (names indexOf: selectedName)).
							patch
								ifNotNil: [ 
									patch isEmpty
										ifTrue: [ 
											wc modified: false.
											aTOMetacelloView currentSession push: 'No changes' selecting: #view ]
										ifFalse: [ 
											wc modified: true.
											aTOMetacelloView currentSession push: patch selecting: #view ].
									main updateCenterSideHistory: s ] ]);
		with: 'changes'.
	(html select)
		id: (id := html nextId);
		list: names;
		selected: selectedName;
		onChange: (html jQuery ajax callback: [ :value | selectedName := value ] value: (html jQuery id: id) value).
! !

!MetacelloProjectSpec methodsFor: '*tode-metacello' stamp: 'dkh 6/27/2011 15:53'!
getOperator

	^operator! !

TOView subclass: #TOAbstractVersion
	instanceVariableNames: 'mbVersionInfo versionMethodSpec aspect aspectPath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 11:48'!
aspect
	aspect ifNil: [ aspect := #versionMethodSpec ].
	^ aspect! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 11:48'!
aspect: aSymbol
	aspect := aSymbol! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 16:35'!
aspectPath
	aspectPath ifNil: [ ^ #() ].
	^ aspectPath! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 16:32'!
aspectPath: aCollection
	aspectPath := aCollection! !

!TOAbstractVersion methodsFor: 'private' stamp: 'dkh 6/24/2011 16:02'!
constructor
	| constructor |
	constructor := MetacelloToolBoxConstructor new.
	constructor setProject: self project.
	constructor configuration: self project configuration class new.
	^ constructor! !

!TOAbstractVersion methodsFor: 'private' stamp: 'dkh 6/24/2011 15:18'!
createVersionMethodSpec
	| constructor version coll pragma imports sourceVersionString vms |
	version := self mbVersionInfo version.
	sourceVersionString := version versionString.
	constructor := self constructor.
	coll := constructor extractAllVersionPragmas at: sourceVersionString ifAbsent: [ ^ nil ].
	coll size > 1
		ifTrue: [ self error: 'More than one pragma defining ' , sourceVersionString printString ].
	pragma := coll at: 1.
	imports := pragma numArgs = 2
		ifTrue: [ pragma argumentAt: 2 ]
		ifFalse: [ #() ].
	vms := (MetacelloVersionMethodSpec new)
		project: self project;
		selector: pragma selector;
		category: (self project configuration class whichCategoryIncludesSelector: pragma selector);
		versionString: sourceVersionString;
		imports: imports;
		yourself.
	constructor extractMethodSectionsFor: sourceVersionString.
	constructor methodSections do: [ :methodSection | vms methodSections add: methodSection ].
	^ vms! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 17:00'!
currentSection
	self aspectPath isEmpty
		ifTrue: [ ^ nil ].
	^ self aspectPath first! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:42'!
indent: count on: html
	count timesRepeat: [ html space ]! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:42'!
indentIncrement

^4! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:42'!
label: labelBlock on: html
	self label: labelBlock value: nil on: html
! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:42'!
label: labelBlock value: valueBlock on: html
	labelBlock
		ifNotNil: [ 
			(html span)
				class: 'keyword';
				with: labelBlock ].
	valueBlock
		ifNotNil: [ 
			(html span)
				class: 'string';
				with: valueBlock ]! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:09'!
mbConfigurationInfo
	mbVersionInfo
		ifNil: [ 
			| wc |
			MCWorkingCopy registry
				do: [ :mgr | 
					(mgr packageInfo includesClass: self actualClass)
						ifTrue: [ wc := mgr ] ].
			wc ifNil: [ ^ nil ].
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = wc packageName
								ifTrue: [ ^ config ] ] ].
			^ nil ].
	^ self mbVersionInfo configurationInfo! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/25/2011 04:30'!
mbVersionInfo
	mbVersionInfo
		ifNil: [ 
			| configurationInfo |
			(configurationInfo := self mbConfigurationInfo)
				ifNotNil: [ 
					| cv |
					(cv := configurationInfo currentVersion)
						ifNotNil: [ mbVersionInfo := configurationInfo infoFor: cv versionString ] ] ].
	^ mbVersionInfo! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/23/2011 16:48'!
mbVersionInfo: anMBVersionInfo
	mbVersionInfo := anMBVersionInfo! !

!TOAbstractVersion methodsFor: 'private' stamp: 'dkh 6/28/2011 20:34'!
memberTypeFor: memberSpec

	^ memberSpec isAdd
		ifTrue: [ 'add' ]
		ifFalse: [ 
			memberSpec isCopy
				ifTrue: [ 'copy' ]
				ifFalse: [ 
					memberSpec isMerge
						ifTrue: [ 'merge' ]
						ifFalse: [ 'remove' ] ] ]! !

!TOAbstractVersion methodsFor: 'private' stamp: 'dkh 6/24/2011 15:21'!
project
	^ self mbVersionInfo project! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/25/2011 05:19'!
renderContentOn: html main: main
	self renderViewContentOn: html main: main! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 14:55'!
renderDescriptionEditor: section on: html main: main
	| id spec fieldValue indent |
	indent := self renderSectionEditorHeading: section on: html main: main.
	self indent: indent on: html.
	spec := section versionSpec.
	fieldValue := spec description value.
	self label: [ html text: 'description: ' ] on: html.
	html break.
	(html textArea)
		id: id;
		columns: (self textAreaColumns: fieldValue);
		rows: (self textAreaRows: fieldValue);
		value: fieldValue;
		callback: [ :value | fieldValue := value ];
		onChange: (html jQuery ajax callback: [ :value | fieldValue := value ] value: (html jQuery id: id) value).
	html break.
	(html submitButton)
		onClick:
				(html jQuery ajax
						script: [ :s | 
							spec description: fieldValue.
							self aspect: #section.
							main updateCenterSideHistory: s ]);
		with: 'Save'.
	html space.
	(html cancelButton)
		onClick:
				((html jQuery id: id)
						script: [ :s | 
							self aspect: #section.
							main updateCenterSideHistory: s ]);
		with: 'Cancel'! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 21:19'!
renderFieldEditor: fieldLabel get: getBlock set: setBlock indent: indent on: html main: main
	| id |
	self indent: indent on: html.
	(html textInput)
		id: (id := html nextId);
		value: getBlock value;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | setBlock value: value ] value: (html jQuery id: id) value;
						script: [ :s | main updateCenterSideHistory: s ]).
	self label: [ html text: fieldLabel ] on: html.
	html break! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 20:16'!
renderGroupEditor: groupSpecMember on: html main: main
	| indent |
	indent := self renderSectionEditorHeading: self currentSection on: html main: main.
	self indent: indent on: html.
	self label: [ html strong: 'groups:' ] on: html.
	html break.
	self indent: indent + self indentIncrement on: html! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/28/2011 20:16'!
renderGroupSpec: groupSpecMember path: path indent: indent on: html main: main
	| blocks groupSpec memberType |
	blocks := OrderedCollection new.
	groupSpec := groupSpecMember spec.
	memberType := self memberTypeFor: groupSpecMember.
	groupSpec includes notEmpty
		ifTrue: [ 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: 'includes: ' on: html.
					groupSpec includes
						do: [ :str | 
							self value: str printString on: html.
							html space ].
					html break ] ].
	self indent: indent on: html.
	self
		renderLink: [ :s | 
			self
				aspect: #group;
				aspectPath: path , {groupSpecMember}.
			main updateCenterSideHistory: s ]
		with: [ self value: [ html strong: groupSpec name ] on: html ]
		on: html.
	html small: ' (' , memberType , '): '.
	blocks isEmpty
		ifTrue: [ ^ html break ].
	blocks size > 1
		ifTrue: [ html break ].
	blocks do: [ :block | block value: blocks size > 1 value: indent + self indentIncrement ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 20:16'!
renderPackageEditor: packageSpecMember on: html main: main
	| indent |
	indent := self renderSectionEditorHeading: self currentSection on: html main: main.
	self indent: indent on: html.
	self label: [ html strong: 'packages:' ] on: html.
	html break.
	self indent: indent + self indentIncrement on: html! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/28/2011 20:21'!
renderPackageSpec: packageSpecMember path: path indent: indent on: html main: main
	| blocks packageSpec memberType |
	packageSpec := packageSpecMember spec.
	blocks := OrderedCollection new.
	memberType := self memberTypeFor: packageSpecMember.
	packageSpec getFile
		ifNotNil: [ :s | 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: [ html text: 'file: ' ] value: [ html text: s value ] on: html.
					html break ] ].
	packageSpec requires notEmpty
		ifTrue: [ 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: 'requires: ' on: html.
					packageSpec requires
						do: [ :str | 
							self value: str printString on: html.
							html space ].
					html break ] ].
	packageSpec includes notEmpty
		ifTrue: [ 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: 'includes: ' on: html.
					packageSpec includes
						do: [ :str | 
							self value: str printString on: html.
							html space ].
					html break ] ].
	packageSpec repositories notEmpty
		ifTrue: [ 
			blocks
				add: [ :doIndent :count | 
					self
						renderRepositoriesSpecs: packageSpec
						path: path , {packageSpecMember}
						indent: indent + self indentIncrement
						on: html
						main: main ] ].
	packageSpec getPreLoadDoIt
		ifNotNil: [ :s | 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: [ html text: 'preLoadDoIt: ' ] on: html.
					(html span)
						class: 'symbol';
						with: s value printString.
					html break ] ].
	packageSpec getPostLoadDoIt
		ifNotNil: [ :s | 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: [ html text: 'postLoadDoIt: ' ] on: html.
					(html span)
						class: 'symbol';
						with: s value printString.
					html break ] ].
	packageSpec answers notEmpty
		ifTrue: [ 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: 'supplyingAnswers: ' on: html.
					html text: '#('.
					packageSpec answers
						do: [ :arrayOfArrays | 
							html text: '#('.
							arrayOfArrays
								do: [ :str | 
									self value: str printString on: html.
									html space ].
							html text: ')' ].
					html text: ')'.
					html break ] ].
	self indent: indent on: html.
	self
		renderLink: [ :s | 
			self
				aspect: #package;
				aspectPath: path , {packageSpecMember}.
			main updateCenterSideHistory: s ]
		with: [ self value: [ html strong: packageSpec name ] on: html ]
		on: html.
	html small: ' (' , memberType , '): '.
	blocks isEmpty
		ifTrue: [ ^ html break ].
	blocks size > 1
		ifTrue: [ html break ].
	blocks do: [ :block | block value: blocks size > 1 value: indent + self indentIncrement ]! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/28/2011 20:17'!
renderPackagesSpecs: versionSpec path: path indent: indent on: html main: main
	| projectSpecs packageSpecs groupSpecs showRepos showProjects showPackages showGroups selected |
	projectSpecs := OrderedCollection new.
	packageSpecs := OrderedCollection new.
	groupSpecs := OrderedCollection new.
	selected := nil.
	self aspectPath size >= 2
		ifTrue: [ selected := self aspectPath at: 2 ].
	showRepos := showProjects := showPackages := showGroups := selected == nil.
	versionSpec repositories = selected
		ifTrue: [ showRepos := true ].
	versionSpec packagesSpec list
		do: [ :member | 
			member spec
				projectDo: [ :proj | 
					member spec name ~~ nil
						ifTrue: [ 
							member = selected
								ifTrue: [ showProjects := true ].
							projectSpecs add: member ] ]
				packageDo: [ :package | 
					member spec name ~~ nil
						ifTrue: [ 
							member = selected
								ifTrue: [ showPackages := true ].
							packageSpecs add: member ] ]
				groupDo: [ :group | 
					member spec name ~~ nil
						ifTrue: [ 
							member = selected
								ifTrue: [ showGroups := true ].
							groupSpecs add: member ] ] ].
	showRepos
		ifTrue: [ 
			self
				renderRepositoriesSpecs: versionSpec
				path: path
				indent: indent
				on: html
				main: main ].
	(showProjects and: [ projectSpecs notEmpty ])
		ifTrue: [ 
			self indent: indent on: html.
			self label: [ html strong: 'projects: ' ] on: html.
			html break.
			projectSpecs
				do: [ :projectSpecMember | 
					(selected isNil or: [ projectSpecMember = selected ])
						ifTrue: [ 
							self
								renderProjectSpec: projectSpecMember
								path: path
								indent: indent + self indentIncrement
								on: html
								main: main ] ] ].
	(showPackages and: [ packageSpecs notEmpty ])
		ifTrue: [ 
			self indent: indent on: html.
			self label: [ html strong: 'packages: ' ] on: html.
			html break.
			packageSpecs
				do: [ :packageSpecMember | 
					(selected isNil or: [ packageSpecMember = selected ])
						ifTrue: [ 
							self
								renderPackageSpec: packageSpecMember
								path: path
								indent: indent + self indentIncrement
								on: html
								main: main ] ] ].
	(showGroups and: [ groupSpecs notEmpty ])
		ifTrue: [ 
			self indent: indent on: html.
			self label: [ html strong: 'groups: ' ] on: html.
			html break.
			groupSpecs
				do: [ :groupSpecMember | 
					(selected isNil or: [ groupSpecMember = selected ])
						ifTrue: [ 
							self
								renderGroupSpec: groupSpecMember
								path: path
								indent: indent + self indentIncrement
								on: html
								main: main ] ] ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 21:21'!
renderProjectEditor: projectSpecMember on: html main: main
	| path blocks projectSpec indent projectReferenceSpec memberType projectPackage |
	indent := self renderSectionEditorHeading: self currentSection on: html main: main.
	projectSpec := projectSpecMember spec.
	projectReferenceSpec := projectSpec referencedSpec.
	projectReferenceSpec ifNotNil: [ projectPackage := projectReferenceSpec projectPackage ].
	memberType := self memberTypeFor: projectSpecMember.
	self indent: indent on: html.
	self label: [ html strong: 'projects:' ] on: html.
	html break.
	indent := indent + self indentIncrement.
	self indent: indent on: html.
	self value: [ html strong: projectSpec name ] on: html.
	html small: ' (' , memberType , '): '.
	html break.
	self
		renderFieldEditor: 'className'
		get: [ projectReferenceSpec className ]
		set: [ :value | projectReferenceSpec className: value ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'versionString'
		get: [ projectReferenceSpec versionString ]
		set: [ :value | projectReferenceSpec versionString: value ]
		indent: indent
		on: html
		main: main.	"
	projectReferenceSpec loads
		ifNotNil: [ :s | 
			blocks
				add: [ :doIndent :count | 
					doIndent
						ifTrue: [ self indent: count on: html ].
					self label: 'loads: ' on: html.
					s
						do: [ :str | 
							self value: str printString on: html.
							html space ].
					html break ] ].
"
	self
		renderFieldEditor: 'operator'
		get: [ projectReferenceSpec getOperator value ]
		set: [ :value | projectReferenceSpec operator: value ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'preLoadDoIt'
		get: [ projectReferenceSpec getPreLoadDoIt value ]
		set: [ :value | projectReferenceSpec preLoadDoIt: value asSymbol ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'postLoadDoIt'
		get: [ projectReferenceSpec getPostLoadDoIt value ]
		set: [ :value | projectReferenceSpec postLoadDoIt: value asSymbol ]
		indent: indent
		on: html
		main: main! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/28/2011 21:17'!
renderProjectSpec: projectSpecMember path: path indent: indent on: html main: main
	| blocks projectSpec projectReferenceSpec memberType projectPackage |
	blocks := OrderedCollection new.
	projectSpec := projectSpecMember spec.
	projectReferenceSpec := projectSpec referencedSpec.
	projectReferenceSpec ifNotNil: [ projectPackage := projectReferenceSpec projectPackage ].
	memberType := self memberTypeFor: projectSpecMember.
	projectReferenceSpec
		ifNotNil: [ 
			projectReferenceSpec className
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: [ html text: 'className: ' ] value: [ html text: s printString ] on: html.
							html break ] ].
			projectReferenceSpec versionString
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: [ html text: 'versionString: ' ] value: [ html text: s printString ] on: html.
							html break ] ].
			projectReferenceSpec loads
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: 'loads: ' on: html.
							s
								do: [ :str | 
									self value: str printString on: html.
									html space ].
							html break ] ].
			projectReferenceSpec getOperator
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: [ html text: 'operator: ' ] on: html.
							(html span)
								class: 'symbol';
								with: s printString.
							html break ] ].
			projectReferenceSpec getPreLoadDoIt
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: [ html text: 'preLoadDoIt: ' ] on: html.
							(html span)
								class: 'symbol';
								with: s value printString.
							html break ] ].
			projectReferenceSpec getPostLoadDoIt
				ifNotNil: [ :s | 
					blocks
						add: [ :doIndent :count | 
							doIndent
								ifTrue: [ self indent: count on: html ].
							self label: [ html text: 'postLoadDoIt: ' ] on: html.
							(html span)
								class: 'symbol';
								with: s value printString.
							html break ] ].
			projectPackage
				ifNotNil: [ 
					projectPackage repositories notEmpty
						ifTrue: [ 
							blocks
								add: [ :doIndent :count | 
									self
										renderRepositoriesSpecs: projectPackage
										path: path , {projectSpecMember}
										indent: indent + self indentIncrement
										on: html
										main: main ] ] ] ].
	self indent: indent on: html.
	self
		renderLink: [ :s | 
			self
				aspect: #project;
				aspectPath: path , {projectSpecMember}.
			main updateCenterSideHistory: s ]
		with: [ self value: [ html strong: projectSpec name ] on: html ]
		on: html.
	html small: ' (' , memberType , '): '.
	blocks isEmpty
		ifTrue: [ ^ html break ].
	blocks size > 1
		ifTrue: [ html break ].
	blocks do: [ :block | block value: blocks size > 1 value: indent + self indentIncrement ]! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/28/2011 16:37'!
renderRepositoriesSpecs: versionSpec path: path indent: indent on: html main: main
	| spec |
	spec := versionSpec repositories.
	spec isEmpty
		ifTrue: [ ^ self ].
	self indent: indent on: html.
	self
		renderLink: [ :s | 
			self
				aspect: #repository;
				aspectPath: path, {spec}.
			main updateCenterSideHistory: s ]
		with: [ self label: [ html strong: 'repositories:' ] on: html ]
		on: html.
	html break.
	spec
		do: [ :repoSpec | 
			self indent: indent + self indentIncrement on: html.
			self renderRepositorySpec: repoSpec on: html main: main.
			html break ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 16:17'!
renderRepositoryEditor: repositoriesSpec on: html main: main
	| indent maxLength |
	indent := self renderSectionEditorHeading: self currentSection on: html main: main.
	self indent: indent on: html.
	self label: [ html strong: 'repositories:' ] on: html.
	html break.
	self indent: indent + self indentIncrement on: html.
	maxLength := 0.
	repositoriesSpec do: [ :repoSpec | maxLength := maxLength max: repoSpec description size ].
	(html textInput)
		value: 'description';
		size: maxLength;
		readonly: true.
	html space.
	(html textInput)
		value: 'user name';
		readonly: true.
	html space.
	(html textInput)
		value: 'password';
		readonly: true.
	html break.
	repositoriesSpec
		do: [ :repoSpec | 
			| did uid pid |
			self indent: indent + self indentIncrement on: html.
			(html textInput)
				id: (did := html nextId);
				value: repoSpec description value;
				size: maxLength;
				onEnter:
						((html jQuery ajax)
								callback: [ :value | repoSpec description: value ] value: (html jQuery id: did) value;
								script: [ :s | main updateCenterSideHistory: s ]).
			html space.
			(html textInput)
				id: (uid := html nextId);
				value: repoSpec username;
				onEnter:
						((html jQuery ajax)
								callback: [ :value | repoSpec username: value ] value: (html jQuery id: uid) value;
								script: [ :s | main updateCenterSideHistory: s ]).
			html space.
			(html passwordInput)
				id: (pid := html nextId);
				value: repoSpec password value;
				onEnter:
						((html jQuery ajax)
								callback: [ :value | repoSpec password: value ] value: (html jQuery id: pid) value;
								script: [ :s | main updateCenterSideHistory: s ]).
			html break ]! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/28/2011 15:52'!
renderRepositorySpec: repositorySpec on: html main: main
	self value: [ html text: repositorySpec description ] on: html.
	(repositorySpec username isEmpty not or: [ repositorySpec password isEmpty not ])
		ifTrue: [ 
			self label: [ html text: ' username: ' ] value: [ html text: repositorySpec username printString ] on: html.
			self label: [ html text: ' password: ' ] value: [ html text: '****' ] on: html ]! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 16:50'!
renderSectionEditor: section on: html main: main
	| indent |
	indent := self renderSectionEditorHeading: section on: html main: main.
	self
		renderVersionSpecEditor: section versionSpec
		path: {section}
		indent: indent + self indentIncrement
		on: html
		main: main.
	self
		renderButton: [ :s | 
			| sessionName |
			main updateAll: s ]
		label: 'add Repository'
		on: html.
	html break.
	self
		renderButton: [ :s | 
			| sessionName |
			main updateAll: s ]
		label: 'add Project'
		on: html.
	html break.
	self
		renderButton: [ :s | 
			| sessionName |
			main updateAll: s ]
		label: 'add Package'
		on: html.
	html break.
	self
		renderButton: [ :s | 
			| sessionName |
			main updateAll: s ]
		label: 'add Group'
		on: html.
	html break! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 14:51'!
renderSectionEditorHeading: section on: html main: main
	| vms indent |
	vms := self versionMethodSpec.
	self label: [ html text: 'version: ' ] on: html.
	html strong: vms versionString.
	vms imports notEmpty
		ifTrue: [ 
			html space.
			self label: [ html text: 'imports: ' ] on: html.
			vms imports
				do: [ :import | 
					self
						renderLink: [ :s | 
							self currentSession push: (self mbVersionInfo configurationInfo infoFor: import) selecting: #view.
							main updateCenterSideHistory: s ]
						with: [ html strong: import ]
						on: html.
					html space ] ].
	html break.
	indent := self indentIncrement.
	self indent: indent on: html.
	(html span)
		class: 'symbol';
		with: [ html text: section attribute printString ].
	html break.
	^ indent! !

!TOAbstractVersion methodsFor: 'rendering-spec' stamp: 'dkh 6/28/2011 18:31'!
renderVersionSpec: spec path: path indent: indent on: html main: main
	spec getBlessing
		ifNotNil: [ 
			self indent: indent on: html.
			self label: [ html text: 'blessing: ' ] on: html.
			(html span)
				class: 'symbol';
				with: spec blessing value printString.
			html break ].
	spec getDescription
		ifNotNil: [ 
			self indent: indent on: html.
			self label: [ html text: 'description: ' ] on: html.
			self
				renderLink: [ :s | 
					self currentSession push: spec description value selecting: #view.
					main updateCenterSideHistory: s ]
				with: [ self value: [ html text: (spec description value printStringLimitedTo: 25) ] on: html ]
				on: html.
			html break ].
	spec getAuthor
		ifNotNil: [ 
			self indent: indent on: html.
			self label: [ html text: 'author: ' ] value: [ html text: spec author value ] on: html.
			html break ].
	spec getTimestamp
		ifNotNil: [ 
			self indent: indent on: html.
			self label: [ html text: 'timestamp: ' ] value: [ html text: spec timestamp value ] on: html.
			html break ].
	spec getPreLoadDoIt
		ifNotNil: [ 
			self indent: indent on: html.
			self label: [ html text: 'preLoadDoIt: ' ] on: html.
			(html span)
				class: 'symbol';
				with: spec preLoadDoIt value printString.
			html break ].
	spec getPostLoadDoIt
		ifNotNil: [ 
			self indent: indent on: html.
			self label: [ html text: 'postLoadDoIt: ' ] on: html.
			(html span)
				class: 'symbol';
				with: spec postLoadDoIt value printString.
			html break ].
! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 21:21'!
renderVersionSpecEditor: spec path: path indent: indent on: html main: main
	self
		renderFieldEditor: 'blessing'
		get: [ spec getBlessing value ]
		set: [ :value | spec blessing: value asSymbol ]
		indent: indent
		on: html
		main: main.
	self indent: indent on: html.
	self label: [ html text: 'description: ' ] on: html.
	self
		renderLink: [ :s | 
			self aspect: #description.
			main updateCenterSideHistory: s ]
		with: [ self value: [ html text: (spec description value printStringLimitedTo: 25) ] on: html ]
		on: html.
	html small: ' (Hint: click to open editor)'.
	html break.
	self
		renderFieldEditor: 'author'
		get: [ spec getAuthor value ]
		set: [ :value | spec author: value ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'timestamp'
		get: [ spec getTimestamp value ]
		set: [ :value | spec timestamp: value ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'preLoadDoIt'
		get: [ spec getPreLoadDoIt value ]
		set: [ :value | spec preLoadDoIt: value asSymbol ]
		indent: indent
		on: html
		main: main.
	self
		renderFieldEditor: 'postLoadDoIt'
		get: [ spec getPostLoadDoIt value ]
		set: [ :value | spec postLoadDoIt: value asSymbol ]
		indent: indent
		on: html
		main: main! !

!TOAbstractVersion methodsFor: 'rendering-editor' stamp: 'dkh 6/28/2011 20:03'!
renderViewContentOn: html main: main
	^ (html span)
		class: 'shout';
		with: [ 
					self aspect == #description
						ifTrue: [ self renderDescriptionEditor: self selectedAspect on: html main: main ].
					self aspect == #section
						ifTrue: [ self renderSectionEditor: self selectedAspect on: html main: main ].
					self aspect == #repository
						ifTrue: [ self renderRepositoryEditor: self selectedAspect on: html main: main ].
					self aspect == #project
						ifTrue: [ self renderProjectEditor: self selectedAspect on: html main: main ].
					self aspect == #package
						ifTrue: [ self renderPackageEditor: self selectedAspect on: html main: main ].
					self aspect == #group
						ifTrue: [ self renderGroupEditor: self selectedAspect on: html main: main ].
					self aspect == #versionMethodSpec
						ifTrue: [ html preformatted: self versionMethodSpec methodSource ] ]! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 17:00'!
selectedAspect
	self aspectPath isEmpty
		ifTrue: [ ^ nil ].
	^ self aspectPath last! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/28/2011 17:16'!
tODEVersionSidebarSpec
	^ {((TOTabSpec new)
		id: #versionSpec;
		renderer:
				((TOVersionSidebar new)
						specLabel: #view;
						object: self;
						yourself);
		receiver: self;
		label: 'version spec';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}
! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/25/2011 05:27'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: self;
		sidebarSpec: self tODEVersionSidebarSpec;
		yourself! !

!TOAbstractVersion methodsFor: 'rendering' stamp: 'dkh 6/28/2011 13:42'!
value: valueBlock on: html
	self label: nil value: valueBlock on: html
! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/24/2011 15:18'!
versionMethodSpec
	versionMethodSpec ifNil: [ versionMethodSpec := self createVersionMethodSpec ].
	^ versionMethodSpec! !

!TOAbstractVersion methodsFor: 'accessing' stamp: 'dkh 6/24/2011 15:17'!
versionMethodSpec: anObject
	versionMethodSpec := anObject! !

TOAbstractVersion subclass: #TOBaselineVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOAbstractVersion subclass: #TOVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOView subclass: #TOConfiguration
	instanceVariableNames: 'mbConfigurationInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/22/2011 10:01'!
classList
	| cv |
	self mbConfigurationInfo ifNil: [ ^ #() ].
	(cv := self mbConfigurationInfo currentVersion) ifNil: [ ^ #() ].
	^ cv currentlyLoadedClassesInVersion! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/22/2011 10:09'!
extensionClassList
	| cv |
	self mbConfigurationInfo ifNil: [ ^ Dictionary new ].
	(cv := self mbConfigurationInfo currentVersion) ifNil: [ ^ Dictionary new ].
	^ cv  currentlyLoadedExtensionClassesInVersion! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:33'!
mbConfigurationInfo
	mbConfigurationInfo
		ifNil: [ 
			| wc |
			MCWorkingCopy registry
				do: [ :mgr | 
					(mgr packageInfo includesClass: self actualClass)
						ifTrue: [ wc := mgr ] ].
			wc ifNil: [ ^nil ].
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = wc packageName
								ifTrue: [ 
									mbConfigurationInfo := config.
									^ config ] ] ] ].
	^ mbConfigurationInfo! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 11:06'!
mbConfigurationInfo: anObject
	mbConfigurationInfo := anObject! !

!TOConfiguration methodsFor: 'rendering-versions' stamp: 'dkh 6/21/2011 21:20'!
nextBaselineVersion
	| latestVersion |
	latestVersion := self mbConfigurationInfo project latestVersion: #baseline.
	latestVersion ifNil: [ ^ '0.1-baseline' ].
	^ latestVersion versionNumber incrementMinorVersionNumber versionString! !

!TOConfiguration methodsFor: 'printing' stamp: 'dkh 6/17/2011 04:37'!
printOn: aStream

super printOn: aStream.
aStream nextPut: $(;
nextPutAll: self mbConfigurationInfo printString;
nextPut: $)! !

!TOConfiguration methodsFor: 'rendering-versions' stamp: 'dkh 6/24/2011 09:27'!
renderAddBaselineCommandOn: html main: main
	| exampleText |
	exampleText := self nextBaselineVersion.
	self
		renderVersionCommand: [ :s :versionString | 
			| configurationInfo baselineVersionString |
			baselineVersionString := versionString ifNil: [ exampleText ].
			configurationInfo := self mbConfigurationInfo.
			(MetacelloToolBox configurationNamed: configurationInfo configurationClass name)
				createVersionMethod: 'baseline' , (MetacelloToolBox stripVersionStringForSelector: baselineVersionString) , ':'
					inCategory: 'baselines'
					forVersion: baselineVersionString;
				addSection: #common
					repository: nil
					requiredProjects: #()
					packages: #()
					dependencies: #()
					groups: #()
					versionSpecsDo: [ :versionSpec | versionSpec blessing: #baseline ];
				commitMethod.
			self pushit: (configurationInfo baselineInfoFor: baselineVersionString) selecting: #view main: main ]
		exampleText: exampleText
		label: 'add baseline'
		on: html
		main: main! !

!TOConfiguration methodsFor: 'rendering-add package' stamp: 'dkh 6/24/2011 09:37'!
renderAddPackageCommandOn: html main: main
	| exampleText packageName id |
	exampleText := ' new packageName'.
	(html textInput)
		id: (id := html nextId);
		exampleText: exampleText;
		value: packageName;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | packageName := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: packageName) ]);
		onChange: (html jQuery ajax callback: [ :value | packageName := value ] value: (html jQuery id: id) value).
	html space.
	self
		renderButton: [ :s | 
			main updateCenterOn: s ]
		label: 'add package'
		on: html! !

!TOConfiguration methodsFor: 'rendering-versions' stamp: 'dkh 6/24/2011 09:27'!
renderAddVersionCommandOn: html main: main
	| exampleText |
	exampleText := '0.1'.
	self
		renderVersionCommand: [ :s :versionString | self pushit: (versionString ifNil: [ exampleText ]) selecting: #view main: main ]
		exampleText: exampleText
		label: 'add version'
		on: html
		main: main! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 6/24/2011 09:40'!
renderCommandsOn: html main: main
	self renderAddBaselineCommandOn: html main: main.
	self mbConfigurationInfo baselines notEmpty
		ifTrue: [ 
			html break.
			self renderAddVersionCommandOn: html main: main ].
	html break.
	self renderAddPackageCommandOn: html main: main.
	self mbConfigurationInfo packages notEmpty
		ifTrue: [ 
			html break.
			self renderPackageChangesCommandOn: html main: main ]! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 6/24/2011 09:25'!
renderContentOn: html main: main
	self mbConfigurationInfo
		ifNil: [ 
			html text: 'No configuration'.
			^ self ].
	self renderCommandsOn: html main: main.
	html break.
	self mbConfigurationInfo renderCommandsOn: html for: self main: main! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 6/24/2011 12:45'!
renderFrameTitleOn: html main: main
	| cl |
	self mbConfigurationInfo ifNil: [ ^ super renderFrameTitleOn: html main: main ].
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	(html div)
		class: 'naviode';
		with: [ 
					self mbConfigurationInfo renderStyledLabelOn: html main: main.
					html space.
					html small: '(' , cl name , ')' ]! !

!TOConfiguration methodsFor: 'rendering-package changes' stamp: 'dkh 6/24/2011 09:26'!
renderPackageChangesCommandOn: html main: main
	| wc |
	self
		renderButton: [ :s | 
			| patches searchResults nameMap count parentCollection linkedItems |
			patches := OrderedCollection new.
			nameMap := IdentityDictionary new.
			(self mbConfigurationInfo packages
				select: [ :mbPackageInfo | (wc := mbPackageInfo workingCopy) notNil and: [ wc ancestors notEmpty and: [ wc modified ] ] ])
				do: [ :mbPackageInfo | 
					| repos names selectedName patch |
					wc := mbPackageInfo workingCopy.
					repos := wc repositoryGroup repositories.
					names := repos collect: [ :r | r description ].
					selectedName := names first.
					patch := wc changesRelativeToRepository: (repos at: (names indexOf: selectedName)).
					nameMap
						at: patch
						put: 'Changes for ' , mbPackageInfo printString , ' (' , patch operations size printString , ' changes)'.
					patches add: patch ].
			linkedItems := OrderedCollection new.
			parentCollection := (TOCollection new)
				directItemLink: true;
				collection: linkedItems;
				printStringBlock: [ :item | item itemLabel ];
				label: 'Changes for: ' , self mbConfigurationInfo printString.
			count := 0.
			searchResults := self
				linkedItemsFor: patches
				withViewerDo: [ :item :viewer | 
					count := count + 1.
					viewer
						parent: parentCollection;
						parentLabel: parentCollection label;
						label: count printString , ' of ' , patches size printString;
						itemLabel: (nameMap at: item).
					linkedItems add: viewer ].
			self currentSession push: searchResults selecting: #view.
			main updateCenterSideHistory: s ]
		label: 'package changes'
		on: html! !

!TOConfiguration methodsFor: 'rendering-versions' stamp: 'dkh 6/24/2011 09:34'!
renderVersionCommand: commandBlock exampleText: exampleText label: label on: html main: main
	| versionString id |
	(html textInput)
		id: (id := html nextId);
		exampleText: exampleText;
		value: versionString;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | versionString := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									commandBlock value: s value: versionString.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: versionString) ]);
		onChange: (html jQuery ajax callback: [ :value | versionString := value ] value: (html jQuery id: id) value).
	html space.
	self
		renderButton: [ :s | 
			commandBlock value: s value: versionString.
			main updateCenterOn: s ]
		label: label
		on: html! !

!TOConfiguration methodsFor: 'rendering' stamp: 'dkh 6/16/2011 10:13'!
renderViewContentOn: html main: main

	self renderContentOn: html main: main
! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/23/2011 17:22'!
tODEConfigurationViewSidebarSpec
	^ {((TOTabSpec new)
		id: #configurationViewClasses;
		renderer: ((TOConfigurationSidebar new) specLabel: #view; yourself);
		receiver: self;
		label: 'configuration view classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/16/2011 11:20'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		renderer: self;
		sidebarSpec: self tODEConfigurationViewSidebarSpec;
		yourself! !

!TOConfiguration methodsFor: 'accessing' stamp: 'dkh 6/13/2011 11:07'!
workingCopy

	^self mbConfigurationInfo workingCopy  ! !

TOView subclass: #TOConfigurationList
	instanceVariableNames: 'configurationSearchResults advancedSearch showDetails repositoryMap searchTerm selectedRepositoryName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOConfigurationList methodsFor: 'create' stamp: 'dkh 6/21/2011 19:29'!
doCreate: projectName main: main
	| configurationClassName |
	configurationClassName := 'ConfigurationOf' , projectName.
	Smalltalk globals
		at: configurationClassName asSymbol
		ifPresent: [ :ex | ^ self pushit: 'Class ' , configurationClassName printString , ' already exists.' selecting: #view main: main ].
	MetacelloToolBox new createConfiguration: projectName.
	self
		pushit: (MBConfigurationRoot current configurationInfoFor: (Smalltalk at: configurationClassName asSymbol))
		selecting: #view
		main: main! !

!TOConfigurationList methodsFor: 'find' stamp: 'dkh 6/21/2011 16:20'!
doSearch: term main: main
	| map searchResults |
	map := self repositoryMapFor: self selectedRepositoryName.
	searchResults := (map keys select: [ :each | each includesSubstring: term caseSensitive: false ]) sorted.
	advancedSearch := nil.
	configurationSearchResults := searchResults collect: [ :name | (map at: name) first ].
	self
		pushit: self
		selecting: #view
		main: main! !

!TOConfigurationList methodsFor: 'private' stamp: 'dkh 6/21/2011 13:03'!
metacelloConfigurationReferencesFrom: aRepository
	| map |
	map := Dictionary new.
	aRepository goferReferences
		do: [ :ref | 
			(ref packageName beginsWith: 'ConfigurationOf')
				ifTrue: [ 
					| nameWithBranch |
					nameWithBranch := ref metacelloPackageNameWithBranch at: 2.
					nameWithBranch := nameWithBranch copyFrom: 'ConfigurationOf' size + 1 to: nameWithBranch size.
					(map at: nameWithBranch ifAbsent: [ map at: nameWithBranch put: OrderedCollection new ]) add: ref ] ].
	^ map! !

!TOConfigurationList methodsFor: 'rendering-search' stamp: 'dkh 6/21/2011 17:15'!
renderAdvancedSearchResultsOn: html main: main
	| names id |
	configurationSearchResults := nil.
	html strong: 'Advanced Search'.
	html break.
	html break.
	names := (self repositories collect: [ :each | each description ]) sorted.
	(names includes: self selectedRepositoryName)
		ifFalse: [ selectedRepositoryName := names first ].
	html text: 'Use '.
	(html select)
		id: (id := html nextId);
		list: names;
		selected: selectedRepositoryName;
		onChange: (html jQuery ajax callback: [ :value | selectedRepositoryName := value ] value: (html jQuery id: id) value).
	html text: ' to search for '.
	(html textInput)
		id: (id := html nextId);
		exampleText: 'ProjectName';
		value: searchTerm;
		script:
				(html jQuery this autocomplete
						sourceCallback: [ :term | 
							| filtered |
							filtered := (self repositoryMapFor: self selectedRepositoryName) keys.
							filtered := (term = '?'
								ifTrue: [ filtered ]
								ifFalse: [ filtered select: [ :each | each includesSubstring: term caseSensitive: false ] ]) sorted.
							filtered size > 12
								ifTrue: [ filtered := filtered first: 24 ].
							filtered ]);
		onEnter:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: searchTerm) ]);
		onChange: (html jQuery ajax callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value).
	html space.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s ]);
		with: 'Find'.
	html break.
	html
		unorderedList: [ 
			html
				small: [ 
					html
						emphasis: [ 
							html text: '('.
							html strong: 'Hint: '.
							html text: 'Type a ''?'' to list all project configurations in repository)' ] ] ]! !

!TOConfigurationList methodsFor: 'rendering' stamp: 'dkh 6/21/2011 19:11'!
renderCommandsOn: html main: main
	self renderSearchCommandOn: html main: main.
	html break.
	self renderCreateCommandOn: html main: main
! !

!TOConfigurationList methodsFor: 'rendering-create' stamp: 'dkh 6/21/2011 19:14'!
renderCreateCommandOn: html main: main
	| id projectName |
	(html textInput)
		id: (id := html nextId);
		exampleText: 'ProjectName';
		value: projectName;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | projectName := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doCreate: projectName main: main.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: projectName) ]);
		onChange: (html jQuery ajax callback: [ :value | projectName := value ] value: (html jQuery id: id) value).
	html space.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | projectName := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doCreate: projectName main: main.
									main updateCenterSideHistory: s ]);
		with: 'Create Project'! !

!TOConfigurationList methodsFor: 'rendering' stamp: 'dkh 6/22/2011 11:17'!
renderProjectListOn: html main: main
	(html div)
		class: 'naviode';
		with: [ 
					MBConfigurationRoot current configurations
						do: [ :config | 
							self
								renderLink: [ :s | 
									self currentSession push: config selecting: #view.
									main updateCenterSideHistory: s ]
								with: [ 
									self showDetails
										ifTrue: [ config renderStyledLabelOn: html main: main ]
										ifFalse: [ 
											(html span)
												class: config todeCssClass;
												with: [ html text: (MBToolBox baseNameOf: config name) ] ] ]
								on: html.
							html break ] ]! !

!TOConfigurationList methodsFor: 'rendering-search' stamp: 'dkh 6/21/2011 17:17'!
renderSearchCommandOn: html main: main
	| id |
	(html textInput)
		id: (id := html nextId);
		exampleText: 'ProjectName';
		value: searchTerm;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: searchTerm) ]);
		onChange: (html jQuery ajax callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value).
	html space.
	(html submitButton)
		onClick:
				((html jQuery ajax)
						callback: [ :value | searchTerm := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									self doSearch: searchTerm main: main.
									main updateCenterSideHistory: s ]);
		with: 'Find Project'.
	html space.
	self
		renderLink: [ :s | 
			advancedSearch := true.
			self pushit: self selecting: #view main: main.
			main updateCenterSideHistory: s ]
		with: [ html text: 'advanced search' ]
		on: html.
	html space.
	html
		small: [ 
			html
				emphasis: [ 
					html text: '('.
					html strong: 'Hint:'.
					html text: ' use this command to find and load a project configuration).' ] ]! !

!TOConfigurationList methodsFor: 'rendering-search' stamp: 'dkh 6/21/2011 17:16'!
renderSearchResultsOn: html main: main
	self renderSearchCommandOn: html main: main.
	html break.
	html break.
	configurationSearchResults
		do: [ :resolvedReference | 
			self
				renderLink: [ :s | 
					| loader |
					loader := MCVersionLoader new.
					loader addVersion: resolvedReference version.
					loader loadWithNameLike: 'tODE'.
					self
						pushit: (MBConfigurationRoot current configurationInfoFor: (Smalltalk at: resolvedReference packageName asSymbol))
						selecting: #view
						main: main.
					self resetSearch.
					main updateCenterSideHistory: s ]
				with: [ html text: 'load' ]
				on: html.
			html space.
			html text: resolvedReference name.
			html break ].
	configurationSearchResults size > 20
		ifTrue: [ 
			html break.
			self renderSearchCommandOn: html main: main ]! !

!TOConfigurationList methodsFor: 'rendering' stamp: 'dkh 6/21/2011 14:01'!
renderViewContentOn: html main: main
	advancedSearch ifNotNil: [ ^ self renderAdvancedSearchResultsOn: html main: main ].
	configurationSearchResults ifNotNil: [ ^ self renderSearchResultsOn: html main: main ].
	self renderProjectListOn: html main: main.
	html break.
	self renderCommandsOn: html main: main! !

!TOConfigurationList methodsFor: 'private' stamp: 'dkh 6/21/2011 13:20'!
repositories
	^ MCRepositoryGroup default repositories reject: [ :repo | repo = MCCacheRepository default ]! !

!TOConfigurationList methodsFor: 'private' stamp: 'dkh 6/21/2011 13:21'!
repositoryMapFor: selectedRepositoryDescription
	repositoryMap ifNil: [ repositoryMap := Dictionary new ].
	^ repositoryMap
		at: selectedRepositoryDescription
		ifAbsent: [ 
			repositoryMap
				at: selectedRepositoryDescription
				put:
					(self
						metacelloConfigurationReferencesFrom:
							(self repositories detect: [ :repo | repo description = selectedRepositoryDescription ])) ]! !

!TOConfigurationList methodsFor: 'accessing' stamp: 'dkh 6/21/2011 16:43'!
resetSearch
	selectedRepositoryName := repositoryMap := configurationSearchResults := advancedSearch := nil! !

!TOConfigurationList methodsFor: 'accessing' stamp: 'dkh 6/21/2011 16:20'!
selectedRepositoryName
	selectedRepositoryName ifNil: [ selectedRepositoryName := 'http://www.squeaksource.com/MetacelloRepository' ].
	^ selectedRepositoryName! !

!TOConfigurationList methodsFor: 'accessing' stamp: 'dkh 6/21/2011 10:23'!
showDetails
	showDetails ifNil: [ showDetails := false ].
	^ showDetails! !

!TOConfigurationList methodsFor: 'accessing' stamp: 'dkh 6/21/2011 10:32'!
showDetails: aBool
	showDetails := aBool! !

TOView subclass: #TOPatch
	instanceVariableNames: 'selectedOperation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPatch methodsFor: '*tode-metacello' stamp: 'dkh 6/16/2011 03:49'!
renderViewContentOn: html main: main

	self selectedOperation ifNil: [html text: 'No operation selected'. ^self].
	self selectedOperation renderContentOn: html view: self main: main  ! !

!TOPatch methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:38'!
selectedOperation
	^ selectedOperation! !

!TOPatch methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:38'!
selectedOperation: anObject
	selectedOperation := anObject! !

TOView subclass: #TOPatchList
	instanceVariableNames: 'mcPatch'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPatchList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:24'!
mcPatch
	^ mcPatch! !

!TOPatchList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:24'!
mcPatch: anObject
	mcPatch := anObject! !

!TOPatchList methodsFor: 'accessing' stamp: 'dkh 6/14/2011 11:34'!
patchView

	^(self frame rendererForCenterTab: #view)! !

!TOPatchList methodsFor: 'rendering' stamp: 'dkh 6/14/2011 14:19'!
renderContentOn: html main: main
	(html div)
		class: 'naviode';
		with: [ 
					(mcPatch operations sorted: [ :a :b | a summary <= b summary ])
						do: [ :operation | 
							| spanClass |
							spanClass := operation isAddition
								ifTrue: [ 'insert' ]
								ifFalse: [ 
									operation isRemoval
										ifTrue: [ 'remove' ]
										ifFalse: [ 'change' ] ].
							self
								renderLink: [ :s | 
									self patchView selectedOperation: operation.
									main updateCenterSideHistory: s ]
								with: [ 
									(html span)
										class: spanClass;
										with: [ 
													self patchView selectedOperation == operation
														ifTrue: [ html strong: operation summary ]
														ifFalse: [ html text: operation summary ] ] ]
								on: html.
							html break ] ]! !

TOView subclass: #TOWorkingCopy
	instanceVariableNames: 'workingCopy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

TOWorkingCopy subclass: #TOPackage
	instanceVariableNames: 'mbPackageInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Metacello'!

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/13/2011 20:32'!
mbPackageInfo
	mbPackageInfo
		ifNil: [ 
			| wc |
			MCWorkingCopy registry
				do: [ :mgr | 
					(mgr packageInfo includesClass: self actualClass)
						ifTrue: [ wc := mgr ] ].
			wc ifNil: [ ^nil ].
			self currentSystem configurationRoot configurations
				do: [ :config | 
					config packages
						do: [ :pkg | 
							pkg basePackageName = wc packageName
								ifTrue: [ 
									mbPackageInfo := pkg.
									^ config ] ] ] ].
	^ mbPackageInfo! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/13/2011 08:18'!
mbPackageInfo: anObject
	mbPackageInfo := anObject! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/24/2011 09:49'!
renderAddClassCommandOn: html main: main
	| exampleText className id |
	exampleText := ' new className'.
	(html textInput)
		id: (id := html nextId);
		exampleText: exampleText;
		value: className;
		onEnter:
				((html jQuery ajax)
						callback: [ :value | className := value ] value: (html jQuery id: id) value;
						script: [ :s | 
									main updateCenterSideHistory: s.
									s << ((html jQuery id: id) value: className) ]);
		onChange: (html jQuery ajax callback: [ :value | className := value ] value: (html jQuery id: id) value).
	html space.
	self renderButton: [ :s | main updateCenterOn: s ] label: 'add class' on: html! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/24/2011 09:47'!
renderCommandsOn: html main: main

	self renderAddClassCommandOn: html main: main.
! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/24/2011 09:44'!
renderContentOn: html main: main
	self mbPackageInfo
		ifNil: [ 
			html text: 'No package'.
			^ self ].
	self renderCommandsOn: html main: main.
	html break.
	self mbPackageInfo renderCommandsOn: html for: self main: main! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/24/2011 12:45'!
renderFrameTitleOn: html main: main
	| cl |
	self mbPackageInfo ifNil: [ ^ super renderFrameTitleOn: html main: main ].
	cl := self isBehavior
		ifTrue: [ self ]
		ifFalse: [ self class ].
	(html div)
		class: 'naviode';
		with: [ 
					self mbPackageInfo renderStyledLabelOn: html main: main.
					html space.
					html small: '(' , cl name , ')' ]! !

!TOPackage methodsFor: 'rendering' stamp: 'dkh 6/16/2011 10:12'!
renderViewContentOn: html main: main

	self renderContentOn: html main: main
! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/25/2011 04:06'!
tODEPackageViewSidebarSpec
	^ {((TOTabSpec new)
		id: #packageViewClasses;
		renderer: ((TOPackageSidebar new) specLabel: #view; yourself);
		receiver: self;
		label: 'package view classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}
! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/16/2011 11:16'!
tODEViewTabSpec
	<tODECenterTabSpec>

	^ (super tODEViewTabSpec)
		sidebarSpec: self tODEPackageViewSidebarSpec;
		yourself! !

!TOPackage methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:05'!
workingCopy

	self mbPackageInfo ifNil: [ ^nil ].
	^self mbPackageInfo workingCopy  ! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:06'!
classList
	
	self workingCopy ifNil: [ ^#() ].
	^ self workingCopy packageInfo classes! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:07'!
extensionClassList
	| classes wc |
	classes := Dictionary new.
	(wc := self workingCopy) ifNil: [ ^ classes ].
	wc packageInfo extensionClasses
		do: [ :cl | 
			| cats fullCats |
			cats := wc packageInfo extensionCategoriesForClass: cl.
			fullCats := OrderedCollection new.
			cats
				do: [ :cat | 
					(cl organization listAtCategoryNamed: cat) notEmpty
						ifTrue: [ fullCats add: cat ] ].
			fullCats notEmpty
				ifTrue: [ classes at: cl put: fullCats ] ].
	^ classes! !

!TOWorkingCopy methodsFor: 'rendering' stamp: 'dkh 6/16/2011 03:50'!
renderViewContentOn: html main: main

	html text: 'work in progress ... do I really need this view ... I want to convert to MBPackageInfo or just use regular inspector ... being able to get MBPackageInfo and going from there is probably a good thing'. ! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:03'!
workingCopy
	^workingCopy! !

!TOWorkingCopy methodsFor: 'accessing' stamp: 'dkh 6/15/2011 16:04'!
workingCopy: aMCWorkingCopy
	workingCopy := aMCWorkingCopy! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/10/2011 21:02'!
renderMetacelloSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/3/2011 17:06'!
renderMetacelloTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/23/2011 17:22'!
tODEConfigurationSidebarSpec
	^ {((TOTabSpec new)
		id: #configurationClasses;
		rendererClass: TOConfigurationSidebar;
		receiver: self;
		label: 'configuration classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 11:14'!
tODEConfigurationTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #configuration;
		rendererClass: TOConfiguration;
		receiver: self;
		label: 'configuration';
		order: 10;
		group: 'monticello';
		sidebarSpec: self tODEConfigurationSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 04:06'!
tODEPackageSidebarSpec
	^ {((TOTabSpec new)
		id: #packageClasses;
		rendererClass: TOPackageSidebar;
		receiver: self;
		label: 'package classes';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/13/2011 11:20'!
tODEPackageTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #package;
		rendererClass: TOPackage;
		receiver: self;
		label: 'package';
		order: 20;
		group: 'monticello';
		sidebarSpec: self tODEPackageSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 04:35'!
tODEVersionSidebarSpec
	^ {((TOTabSpec new)
		id: #versionSpec;
		rendererClass: TOVersionSidebar;
		receiver: self;
		label: 'version spec';
		order: 50;
		group: 'monticello';
		renderSelector: #renderMetacelloSidebarOn:spec:tOdeMain:)}! !

!Object methodsFor: '*tode-metacello' stamp: 'dkh 6/25/2011 04:35'!
tODEVersionTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #version;
		rendererClass: TOVersion;
		receiver: self;
		label: 'version';
		order: 15;
		group: 'monticello';
		sidebarSpec: self tODEVersionSidebarSpec;
		renderSelector: #renderMetacelloTabOn:spec:tOdeMain:! !
